﻿var Analytics = {

  videoItemQueryOpen: false

};

// ------------------------------------------------

Analytics.itemOpen = function (item) {

  //Main.log("Analytics.itemOpen: " + item);

  if (item == null)
    return;

  //Main.log("Analytics.itemOpen url: " + item.Url);

  Timeline.duration = 0;

  this.videoItemQueryOpen = true;

  this.callAnalytics(item.Url);

};

// ------------------------------------------------

Analytics.itemClose = function (item) {

  //Main.log("Analytics.itemClose: " + item);

  if (item == null)
    return;

  //Main.log("Analytics.itemClose: Display.totalTime: " + Timeline.total);
  this.callAnalytics(item.Url + "&AnaPlaytime=" + Timeline.duration + "&AnaLength=" + Timeline.total);
  this.videoItemQueryOpen = false;

};

// ------------------------------------------------

Analytics.getTimeDiff = function (date1, date2) {

  dt1 = new Date(date1);
  dt2 = new Date(date2);

  var diff;

  if (dt1 > dt2) {
    diff = new Date(dt1 - dt2);
  } else {
    diff = new Date(dt2 - dt1);
  }

  return diff;
};

// ------------------------------------------------

Analytics.callAnalytics = function (link) {

  ////Main.log("callAnalytics: " + eval(Main.setting.App.Analytics.AllowAnalytics));

  if (eval(Main.setting.App.Analytics.AllowAnalytics)) {

    //Main.log("callAnalytics link: " + Main.setting.Server + link);

    $.ajax({
      type: "GET",
      url: Main.setting.Server + link,
      contentType: "application/json; charset=utf-8",
      dataType: "json",
      timeout: 10000,
      processdata: false,
      success: function (data) {

        //Main.log("callAnalytics success: " + Main.setting.Server + link);

      }

    });

  }

};

// ------------------------------------------------


