﻿Storage = {

  data: new Array(),
  fileName: "data.txt",
  fileSystem: new FileSystem()

};

// -----------------------------------------------

Storage.init = function () {

  var fileSystemObj = new FileSystem();
  var fileObj = fileSystemObj.openCommonFile(this.fileName, 'r');

  if (fileObj == null)
    fileObj = fileSystemObj.openCommonFile(this.fileName, 'w');

}

// -----------------------------------------------

Storage.clearFile = function () {

  var fileSystemObj = new FileSystem();
  fileSystemObj.openCommonFile(this.fileName, 'w');

}

// -----------------------------------------------

Storage.SaveData = function () {

  var fileSystemObj = new FileSystem();
  var fileObj = fileSystemObj.openCommonFile(this.fileName, 'w');

  var strLine = "";
  for (var key in this.data) {

    var itemKey = key;
    var value = this.data[key];
    strLine = key + "=" + value;
    //alert("!!! save strLine:" + strLine);
    fileObj.writeLine(strLine);
  }

  fileSystemObj.closeFile(fileObj);

};

// -----------------------------------------------

Storage.LoadData = function () {

  //Main.log("Storage.LoadData...");

  this.data = [];

  var fileSystemObj = new FileSystem();
  var fileObj = fileSystemObj.openCommonFile(this.fileName, 'r');

  var strLine = "";
  while ((strLine = fileObj.readLine())) {

    //alert("!!! load strLine:" + strLine);
    var index = strLine.indexOf("=");
    var key = strLine.substring(0, index);
    var value = strLine.substring(index + 1, strLine.length);
    if (value == "null") value = null;
    this.data[key] = value;
  }

  fileSystemObj.closeFile(fileObj);
};

// -----------------------------------------------

Storage.setData = function (data) {
  this.data = data;
  this.SaveData();
};

// -----------------------------------------------

Storage.getData = function () {
  this.LoadData();
  return this.data;
};

// -----------------------------------------------

Storage.getItem = function (key) {

  var value = "";
  this.LoadData();

  for (var itemKey in this.data) {

    if (itemKey == key) {
      var value = this.data[key];
    }
  }

  this.data = [];

  return value;
};

// -----------------------------------------------

Storage.put = function (key, value) {

  this.LoadData();

  this.data[key] = value;

  this.SaveData();
};

// -----------------------------------------------

Storage.clear = function (key, value) {

  this.data = [];
  this.SaveData();
};

// -----------------------------------------------



