﻿
$(document).ready(function () {

  //Main.logInfo("jQuery ready...");

  Main.init();
  Focus.init();


  Focus.setFocusToElement($("#splashLinks"));

  $("body").bind("controlCreated", function (event, message) {

    Main.controlCouter++;

    //Main.log("........................................................................ " + Main.setting.App.InitControlsCount + " " + Main.controlCouter + " " + message);

    if (Main.controlCouter == Main.setting.App.InitControlsCount) {
      $("body").trigger('appReady', [null]);
    }

  });

});

// ----------------------------------

Main = {

  setting: null,
  controlCouter: 0

};

// ----------------------------------

Main.init = function () {

  var _this = this;

  $.ajax({
    url: "setting.json",
    dataType: 'json',
    data: null,
    success: function (data) {
      _this.setting = data;

      Service.init();

      Player.init();
      Storage.init();

      $("body").trigger('initControls', [null]);

    },
    error: function () {
      //Main.logError("loading setting.json error!");
    }
  });

};

// ----------------------------------

Main.log = function (message) {

 this.logInfo(message);

};

// ----------------------------------

Main.logInfo = function (message) {

//  if (parseFloat($.browser.version) > 5) {
//    console.log(message);
//  } else {
//   alert("FC Bayern -info------: " + message);
//  }

};

// ----------------------------------

Main.logError = function (message) {

//  if (parseFloat($.browser.version) > 5) {
//    console.log(message);
//  } else {
//    alert("FC Bayern -error-----: " + message);
//  }

};

// ----------------------------------

Main.onLoad = function () {

    window.onShow = onShowEvent;

    pluginAPI = new Common.API.Plugin();
    widgetAPI = new Common.API.Widget();
    tvKey = new Common.API.TVKeyValue();

    Audio.init();
    //Key.initKeys();
    Storage.init();

    Template.checkVersion();

    widgetAPI.sendReadyEvent();
    document.getElementById("anchor").focus();

};

// ----------------------------------

onShowEvent = function () {

  //Main.log("onShowEvent...");

  /// <summary>Unregistering and registering key events.</summary>

  //pluginAPI.SetBannerState(1);
  var nnaviPlugin = document.getElementById("pluginObjectNNavi");
  nnaviPlugin.SetBannerState(2);
  // For volume OSD
  pluginAPI.unregistKey(tvKey.KEY_VOL_UP);
  pluginAPI.unregistKey(tvKey.KEY_VOL_DOWN);
  pluginAPI.unregistKey(tvKey.KEY_MUTE);
  // For Menu key, Info.L key 
  pluginAPI.unregistKey(tvKey.KEY_EXIT);

  pluginAPI.unregistKey(tvKey.KEY_MENU);
  //pluginAPI.unregistKey(tvKey.KEY_INFOLINK);
  //pluginAPI.unregistKey(tvKey.KEY_TOOLS);
  pluginAPI.unregistKey(tvKey.KEY_SOURCE);


};

// ----------------------------------

Main.setOffScreenSaver = function () {

    pluginAPI.setOffScreenSaver();

};

// ----------------------------------

Main.setOnScreenSaver = function () {

    pluginAPI.setOnScreenSaver();

};

// ----------------------------------

