﻿
String.prototype.contains = function (it) {
  return this.indexOf(it) != -1;
};

String.prototype.trim = function () {
  return this.replace(/^\s*/, "").replace(/\s*$/, "");
}

// ---------------------------------

var tvSubControlsCounter = 0;
var newsSubControlsCounter = 0;
var matchSubControlsCounter = 0;

var tickerCounter = 1;

$(document).ready(function () {


    $("body").bind("appReady", function (event, message) {

        //Main.log("appReady " + Main.setting.App.Analytics.AppOpenUrl);

        Service.get(Main.setting.Server + "/Json/JsonWebService.aspx?Client=SamsungTV&cc=DE-DE&EplName=FCBayern&ServiceOperation=GetContent&PageType=Intro", null, "intro", "createIntro");

        Analytics.callAnalytics(Main.setting.App.Analytics.AppOpenUrl);

    });

    // ---

    $("body").bind("keyPressed", function (event, key) {

        switch (key) {
            case "red":

                if (Template.isLoginDisplayed || Template.isImpressumDisplayed || Template.isErrorDisplayed || Player.state == Player.PLAYING) return;
                if (Player.display == Player.FULLSCREEN) return;

                if (!Template.isLogged) {
                    Template.isLoginDisplayed = true;
                    Template.lastFocusedControlId = Focus.focusedControlId;
                    LoginContainer.control.Login.startLoginForm();
                } else {
                    Template.isLogged = false;
                    LoginContainer.control.Login.logout();
                    StatusContainer.control.Status.setInfoText("");
                    //Storage.init();
                }
                break;
            case "green":

                //Main.log(Template.appState);

                if (Template.isLoginDisplayed || Template.isImpressumDisplayed || Template.isErrorDisplayed) return;
                if (Template.currentModule != Template.VIDEO) return;
                if (Player.display == Player.FULLSCREEN) return;

                switch ($(".focus").attr("id")) {
                    case "Player":
                        PlayerContainer.control.Player.leaveControl(null);
                        Focus.setFocusToElement($("#Menu"));
                        break
                    case "Carousel":
                        CarouselContainer.control.Carousel.leaveControl(null);
                        Focus.setFocusToElement($("#Menu"));
                        break
                    case "Remote":
                        RemoteContainer.control.Remote.leaveControl(null);
                        Focus.setFocusToElement($("#Menu"));
                        break
                }

                break;
            case "yellow":
                // ###
                //$("body").trigger('networkError', ["onRenderError"]);
                break;
            case "blue":

                if (Template.isLoginDisplayed || Template.isImpressumDisplayed || Template.isErrorDisplayed) return;
                if (Player.display == Player.FULLSCREEN) return;
                if (Player.state == Player.PLAYING) Player.pauseVideo();

                Template.isImpressumDisplayed = true;
                Template.lastFocusedControlId = Focus.focusedControlId;
                Service.get(Main.setting.Server + "/Json/JsonWebService.aspx?Client=SamsungTV&cc=DE-DE&EplName=FCBayern&ServiceOperation=GetContent&PageType=Imprint", null, "impressum", "impressumFillText");

                break;
            case "play":

                if (Template.isLoginDisplayed || Template.isImpressumDisplayed || Template.isErrorDisplayed) return;
                if (Template.currentModule != Template.VIDEO) return;
                if (Player.state == Player.PLAYING) return;

                //if (LoginContainer.control.Login.isUserLogged) {
                //  CarouselContainer.control.Carousel.clearFocus()
                //  Focus.setFocusedControlId("Remote");
                //}

                if (Player.state == Player.PAUSED) {
                    Player.playVideo();
                } else {
                    //Template.swithPlayerLayersToVideo();
                    Template.lastFocusedControlId = $(".focus").attr("id");
                    Template.AnalyticsItemOpen = Template.dataVideo.Content.ContentItems[Template.videoIndex].AnalyticsItemShow;
                    Template.AnalyticsItemClose = Template.dataVideo.Content.ContentItems[Template.videoIndex].AnalyticsItemClose;

                    Player.Stop();
                    LoginContainer.control.Login.startAuthentication(Template.dataVideo.Content.ContentItems[Template.videoIndex].MediaUrl);
                }

                //Template.swithPlayerLayersToVideo();
                //Player.playVideo();
                break;
            case "pause":

                if (Template.isLoginDisplayed || Template.isImpressumDisplayed || Template.isErrorDisplayed) return;
                if (Template.currentModule != Template.VIDEO) return;

                Player.pauseVideo();
                break;
            case "stop":

                if (Template.isLoginDisplayed || Template.isImpressumDisplayed || Template.isErrorDisplayed) return;
                if (Template.currentModule != Template.VIDEO) return;

                Player.Stop();

                break;
        }

    });

    // ---

    $("body").bind("serviceResult", function (event, data, status, resultType, callback) {

        var dataForTemplate = false;

        switch (status) {
            case "success":
                if (resultType == "intro") {
                    Template.dataIntro = data;
                    dataForTemplate = true;
                }
                if (resultType == "splash") {
                    Template.dataSplash = data;
                    dataForTemplate = true;
                }
                if (resultType == "tv") {
                    Template.dataTv = data;
                    dataForTemplate = true;
                }
                if (resultType == "news") {
                    Template.dataNews = data;
                    dataForTemplate = true;
                }
                if (resultType == "match") {
                    Template.dataMatch = data;
                    dataForTemplate = true;
                }
                if (resultType == "ticker") {
                    Template.dataTicker = data;
                    dataForTemplate = true;
                }
                if (resultType == "videoList") {
                    Template.dataVideo = data;
                    dataForTemplate = true;
                }
                if (resultType == "impressum") {
                    Template.dataImpressum = data;
                    dataForTemplate = true;
                }

                if (dataForTemplate) eval("Template." + callback + "();");

                break;
            case "error":
                $("body").trigger('networkError', ["onNetworkDisconnected"]);
                break;
        }

    });

    // ---

    $("body").bind("splashBoxPressed", function (event, link) {

        SplashContainer.control.Splash.hide();
        SplashContainer.control.Splash.leaveControl(null);

        switch (link) {
            case "News":
                var callUrl = Main.setting.Server + "/Json/JsonWebService.aspx?Client=SamsungTV&cc=DE-DE&EplName=FCBayern&ServiceOperation=GetContent&PageType=TVApp&ServiceName=News&ChannelType=Channels";
                Service.get(callUrl, null, "news", "createNews");
                //Template.createNews();
                //Main.log("Template: " + callUrl);
                break;
            case "Match":
                Service.get(Main.setting.Server + "/Json/JsonWebService.aspx?Client=SamsungTV&cc=DE-DE&EplName=FCBayern&ServiceOperation=GetContent&PageType=TVApp&ServiceName=Match&ChannelType=Channels", null, "match", "createMatch");
                //Template.createMatch();
                break;
            case "FCBayernTV":
                Service.get(Main.setting.Server + "/Json/JsonWebService.aspx?ServiceOperation=GetNavigation&Client=SamsungTV&cc=DE-DE&EplName=FCBayern&PageType=TVApp&ServiceName=FCBayernTV", null, "tv", "createTV");
                //Template.createTV();
                break;
        }

    });

    // ---

    $("body").bind("tvReturnPressed matchReturnPressed newsReturnPressed menuReturnPressed carouselReturnPressed playerReturnPressed remoteReturnPressed newsEntriesReturnPressed artikelReturnPressed tickerReturnPressed matchAktuelReturnPressed webradioReturnPressed", function (event, controlId) {

        Template.currentModule = Template.SPLASH;
        Template.isVideoMode = false;

        // TV
        Player.hide();
        Player.Stop();
        $("#Remote").remove();
        $("#videoImage").hide();
        $("#videoOverlay").hide(); ;
        //$("#pluginObjectPlayer").hide();
        $("#pluginObjectPlayer").css('visibility', 'hidden');


        if (PlayerContainer.control.Player != undefined) PlayerContainer.control.Player.deinit();
        if (CarouselContainer.control.Carousel != undefined) CarouselContainer.control.Carousel.deinit();
        if (MenuContainer.control.Menu != undefined) MenuContainer.control.Menu.deinit();
        if (RemoteContainer.control.Remote != undefined) RemoteContainer.control.Remote.deinit();

        MenuContainer.control.Menu = null;
        CarouselContainer.control.Carousel = null;
        RemoteContainer.control.Remote = null;
        PlayerContainer.control.Player = null;

        // News
        if (NewsEntriesContainer.control.NewsEntries != undefined) NewsEntriesContainer.control.NewsEntries.deinit();
        if (ArtikelContainer.control.Artikel != undefined) ArtikelContainer.control.Artikel.deinit();

        NewsEntriesContainer.control.NewsEntries = null;
        ArtikelContainer.control.Artikel = null;


        // Match
        clearTimeout(timerTicker);
        tickerCounter = 1;

        if (WebradioContainer.control.Webradio != undefined) WebradioContainer.control.Webradio.deinit();
        if (TickerContainer.control.Ticker != undefined) TickerContainer.control.Ticker.deinit();

        WebradioContainer.control.Webradio = null;
        TickerContainer.control.Ticker = null;

        TVsContainer.control.TV.hide();
        NewsContainer.control.News.hide();
        MatchContainer.control.Match.hide();


        tvSubControlsCounter = 0;
        newsSubControlsCounter = 0;
        matchSubControlsCounter = 0;

        Service.hideLoader();

        SplashContainer.control.Splash.takeControl();
        SplashContainer.control.Splash.show();


    });

    // ---

    $("body").bind("menuEnterPressed", function (event, selectedCategorieIndex, selectedItemIndex, itemType, first) {

        //Main.log("Template: menuEnterPressed ----------------------------------------");

        Template.menuFirsLoad = first;

        var link = null;
        if (itemType == "DataProvider") {
            link = Template.dataTv.Navigation.Items[selectedCategorieIndex].Link.Url;
        }
        else {
            link = Template.dataTv.Navigation.Items[selectedCategorieIndex].Items[selectedItemIndex].Link.Url;
        }

        //Main.log("menuEnterPressed: " + Template.menuFirsLoad);
        Service.get(Main.setting.Server + "/" + link, null, "videoList", "createVideoList");
        RemoteContainer.control.Remote.doIsPlaying(false);

    });

    // ---

    $("body").bind("carouselEnterPressed", function (event, videoIndex) {

        Timeline.duration = 0;
        Timeline.totalTime = 0;
        Timeline.setTime(0);

        $("#videoOverlay .videoTitle").html(Template.dataVideo.Content.ContentItems[videoIndex].Title);

        //Template.swithPlayerLayersToVideo();
        Template.lastFocusedControlId = "Carousel";
        Template.AnalyticsItemOpen = Template.dataVideo.Content.ContentItems[videoIndex].AnalyticsItemShow;
        Template.AnalyticsItemClose = Template.dataVideo.Content.ContentItems[videoIndex].AnalyticsItemClose;

        Player.Stop();
        LoginContainer.control.Login.startAuthentication(Template.dataVideo.Content.ContentItems[videoIndex].MediaUrl);

    });

    // ---

    $("body").bind("playerEnterPressed", function (event, message) {

        //Main.log(Template.videoUrl);

        Template.lastFocusedControlId = "Player";
        Template.AnalyticsItemOpen = Template.dataVideo.Content.ContentItems[Template.videoIndex].AnalyticsItemShow;
        Template.AnalyticsItemClose = Template.dataVideo.Content.ContentItems[Template.videoIndex].AnalyticsItemClose;



        //Template.isVideoMode = false;
        Player.Stop();
        LoginContainer.control.Login.startAuthentication(Template.videoUrl);


    });

    // ---

    $("body").bind("newsEntriesEnterPressed", function (event, entryId) {
        ArtikelContainer.control.Artikel.loadContent(entryId);
        Focus.setFocusToElement($("#Artikel"));
    });

    // ---

    $("body").bind("subControlCreated", function (event, controlId, parentId) {

        switch (parentId) {
            case "TV":
                tvSubControlsCounter++;
                if (tvSubControlsCounter != Main.setting.Controls.TV.SubcontrolsCount)
                    return;

                CarouselContainer.control.Carousel.createContent();
                RemoteContainer.control.Remote.createContent();
                MenuContainer.control.Menu.createMenuContent(Template.dataTv.Navigation.Items);

                Focus.setFocusToElement($("#Menu"));
                MenuContainer.control.Menu.doDefaultAction();
                CarouselContainer.control.Carousel.clearFocus();

                $("#videoImage img.videoImage").attr("src", "");
                Template.swithPlayerLayersToImage();
                $("#videoImage").show();

                break;
            case "News":
                newsSubControlsCounter++;
                if (newsSubControlsCounter != Main.setting.Controls.News.SubcontrolsCount)
                    return;

                NewsEntriesContainer.control.NewsEntries.createContent(Template.dataNews.Content.ContentItems);
                Focus.setFocusToElement($("#NewsEntries"));

                ArtikelContainer.control.Artikel.createContent(0);

                setTimeout(function () {
                    //NewsEntriesContainer.control.NewsEntries.pressEnter();
                    Service.hideLoader();
                }
                , 3000);

                //   NewsEntriesContainer.control.NewsEntries.doDefaultAction();

                break;
            case "Match":
                matchSubControlsCounter++;
                if (matchSubControlsCounter != Main.setting.Controls.Match.SubcontrolsCount)
                    return;

                //MatchAktuelContainer.control.MatchAktuel.createDummyContent();

                Focus.setFocusToElement($("#Ticker"));

                break;
        }

    });

    // ---

    $("body").bind("remoteAction", function (event, action) {

        switch (action) {
            case "pause":
                ////Main.log("remoteAction: pause");
                //Service.hideLoader();
                Player.pauseVideo();
                break;
            case "play":

                //Template.swithPlayerLayersToVideo();
                //Player.playVideo();

                //Service.hideLoader();
                //Template.swithPlayerLayersToVideo();

                //if (Player.state == Player.PAUSED) {
                //  //Main.log("remoteAction: play and resume");
                //  Player.resumeVideo();
                //} else {
                //  //Main.log("remoteAction: play");
                //  Player.setVideoURL(Template.videoUrl);
                //  Player.playVideo();
                //Service.showLoaderWithPosition(Main.setting.Preloaders.Video);
                // }
                break;
            case "stop":
                //Main.log("remoteAction: stop");
                Player.Stop();
                Focus.setFocusedControlId("Carousel");
                Template.swithPlayerLayersToImage();
                break;
            case "resume":
                //Main.log("remoteAction: resume");
                Player.resumeVideo();
                break;
            case "fullscreen":
                //Main.log("remoteAction: fullscreen");
                Template.hideOverlay();
                Player.setFullscreen();
                break;
            case "screenbox":
                //Main.log("remoteAction: screenbox");
                Player.state = Player.PLAYING
                RemoteContainer.control.Remote.playPauseState = RemoteContainer.control.Remote.PLAY;

                Template.showOverlay();
                Player.setWindow();
                Player.state = Player.PLAYING
                $("#PlayerPlay img").attr("src", "Theme/FCBayern/Images/Pause.png");
                break;

        }

    });

    // ---

    $("body").bind("playerStateChanged", function (event, status) {

        switch (status) {
            case Player.STOPPED:
                //Main.log("Template Player stoped");

                $("#PlayerPlay img").attr("src", "Theme/FCBayern/Images/Play.png");

                Service.hideLoader();

                if (Template.isVideoMode) {

                    if (MenuContainer.control.Menu == null)
                        MenuContainer.control.Menu.clearFocus();

                    Focus.setFocusedControlId("Carousel");
                    Template.swithPlayerLayersToImage();
                    Analytics.itemClose(Template.AnalyticsItemClose);
                    Main.setOnScreenSaver();
                }

                break;
            case Player.PLAYING:
                //Main.log("Template Player plaing");
                $("#PlayerPlay img").attr("src", "Theme/FCBayern/Images/Pause.png");
                Template.swithPlayerLayersToVideo();
                Service.hideLoader();
                Main.setOffScreenSaver();
                break;
            case Player.PAUSED:
                $("#PlayerPlay img").attr("src", "Theme/FCBayern/Images/Play.png");
                //Main.log("Template Player paused");
                break;
            case Player.FULLSCREEN:
                //Main.log("Template Player fullscreen");
                break;
            case Player.WINDOW:
                //Main.log("Template Player window");
                break;
            case Player.LOADING:
                //Main.log("Template Player loading");
                Service.showLoaderWithPosition(Main.setting.Preloaders.Video);
                break;
            case Player.RESUMED:
                //Main.log("Template Player resumed");
                $("#PlayerPlay img").attr("src", "Theme/FCBayern/Images/Pause.png");
                Service.hideLoader();
                Main.setOffScreenSaver();
                break;
            case Player.COMPLETE:

                if (Template.appState == Template.INTRO) {
                    //Main.log("Template Player complete intro");
                    Player.state = Player.STOPPED;
                    Player.display = Player.WINDOW;
                    Template.videoUrl = "";
                    Player.setVideoURL("");
                    Player.Stop();
                    Template.appState = null;
                    $("#context").addClass("ready");
                    IntroContainer.control.Intro.introFinished();
                } else {
                    //Main.log("Template Player complete render");
                    Player.Stop();
                }

                break;
            default:
                //Main.log("Template Player default action... " + status);
                break;
        }

    });

    // ---

    $("body").bind("doAuthenticatedAction", function (event, streamUrl) {

        //Main.log("doAuthenticatedAction -stream url: " + streamUrl);

        Timeline.reset();

        Template.lastFocusedControlId = "Remote";
        CarouselContainer.control.Carousel.clearFocus();



        Template.swithPlayerLayersToVideo();

        Template.videoUrl = streamUrl;
        //Player.Stop();
        Analytics.itemOpen(Template.AnalyticsItemOpen);
        Player.setVideoURL(streamUrl);
        Player.playVideo();
        RemoteContainer.control.Remote.doIsPlaying(true);

        Focus.setFocusedControlId("Remote");

    });

    // ---

    $("body").bind("loginReturnPressed", function (event, message) {

        Template.isLoginDisplayed = false;
        Input.hideInput();

        //Main.log("loginReturnPressed: " + Template.lastFocusedControlId);

        if (Template.lastFocusedControlId != null) {
            Focus.setFocusedControlId(Template.lastFocusedControlId);
        }

    });

    // ---

    $("body").bind("loginStatusChange", function (event, status, userName) {

        switch (status) {
            case "logged":
                Template.isLogged = true;
                StatusContainer.control.Status.setInfoText(Main.setting.Controls.Login.WecomeMessage + userName + "!");
                break;
        }

    });

    // ---

    $("body").bind("carouselAfterMove", function (event, direction, imgSrc, index) {

        if (Template.dataVideo == undefined || imgSrc == undefined)
            return;


        //if (direction != "first") {
        Template.videoUrl = Template.dataVideo.Content.ContentItems[index].MediaUrl;
        Template.videoIndex = index;
        //}


        //if (!Template.isVideoMode)
        Template.displayImage(imgSrc, Template.dataVideo.Content.ContentItems[index].Title, Template.dataVideo.Content.ContentItems[index].PubDate);


    });

    // ---

    $("body").bind("playerSetFocus", function (event, message) {

        $("#videoImage img.bigPlayButton").show();

    });

    // ---

    $("body").bind("carouselSetFocus menuSetFocus", function (event, message) {

        $("#videoImage img.bigPlayButton").hide();

    });

    // ---

    $("body").bind("carouselFocusMove", function (event, direction) {

        //Main.log("carouselFocusMove " + direction + " " + Template.isVideoMode);

        switch (direction) {
            case "up":
                if (Template.isVideoMode)
                    Focus.setFocusedControlId("Remote");
                else
                    Focus.setFocusedControlId("Player");
                break;
        }

    });

    // ---

    $("body").bind("menuFocusMove", function (event, direction) {

        //Main.log("carouselFocusMove " + direction + " " + Template.isVideoMode);

        switch (direction) {
            case "left":
                if (Template.isVideoMode)
                    Focus.setFocusedControlId("Remote");
                else
                    Focus.setFocusedControlId("Player");
                break;
        }

    });

    // ---

    $("body").bind("remoteLeaveControl", function (event, message) {
        RemoteContainer.control.Remote.hide();
        Template.hideOverlay();
    });

    // ---

    $("body").bind("remoteVisibilityStateChange", function (event, status) {

        switch (status) {
            case "show":
                Template.showOverlay();
                break;
            case "hide":
                Template.hideOverlay();
                break;
        }

    });

    // ---

    $("body").bind("tickerTimerElapsed", function (event, message) {
        //Main.log("tickerTimerElapsed.............................");

        MatchContainer.control.Match.createTimer(parseInt(MatchAktuelContainer.control.MatchAktuel.UpdateTimespan) * 1000);

        if (Template.isImpressumDisplayed)
            return;

        if (Template.isErrorDisplayed)
            return;

        if (Template.isLoginDisplayed)
            return;

        Service.get(Template.dataMatch.Content.ContentItems[0].MediaUrl, null, "ticker", "updateTicker");

    });

    // ---

    $("body").bind("splashReturnPresed", function (event, message) {
        Key.sendReturn();
    });

    // ---

    $("body").bind("loginSetFirstFocus", function (event, message) {

        //setTimeout("document.getElementById('LoginInputName').focus();", 300);

        allowReturn = false;
        setTimeout(function () {
            Input.showInput();
            document.getElementById('LoginInputName').focus();
            allowReturn = true;
        }, 1000);

    });

    // ----

    $("body").bind("loginMove", function (event, direction, elementId) {

        switch (elementId) {
            case "LoginInputPassword":
                document.getElementById(elementId).focus();
                Input.showInput();
                break;
            case "LoginInputName":
                document.getElementById(elementId).focus();
                Input.showInput();
                break;
            default:
                document.getElementById("dummy-input").focus();
                Input.hideInput();
                break;
        }

        //setTimeout("document.getElementById('LoginInputName').focus(); Input.showInput();", 1000);

    });

    // -----

    $("body").bind("loginShow", function (event, message) {

        Storage.clearFile();
        StatusContainer.control.Status.setInfoText("");

        LoginContainer.control.Login.show();
        LoginContainer.control.Login.takeControl();
        Focus.setFocusToElement($("#Login"));

        for (var i = 0; i < elementIds.length; i++) {
            if (inputs[i] != null)
                inputs[i].ime = null;

            inputs[i] = null;
        }

        //if (!imeCreated)
        Input.createInputObjects();

    });

    // -----

    $("body").bind("loginFormLeave", function (event, message) {

        Input.hideInput();

        Template.isLoginDisplayed = false;

        if (Template.lastFocusedControlId != null) {
            Focus.setFocusedControlId(Template.lastFocusedControlId);
        }

    });

    // -----

    $("body").bind("impressumReturnPressed", function (event, message) {

        Template.isImpressumDisplayed = false;
        Template.isErrorDisplayed = false;

        if (Player.state == Player.PAUSED)
            Player.resumeVideo();

        if (Template.lastFocusedControlId != null) {
            Focus.setFocusedControlId(Template.lastFocusedControlId);
        }

    });

    // -----

    $("body").bind("errorReturnPressed", function (event, message) {

        Key.sendReturn();

    });

    // -----

    $("body").bind("webradioEnterPressed", function (event, message) {
        Audio.plugin.SetSystemMute(false);
        //Player.playAudioStream("http://www.antenne.de/webradio/antenne.m3u");

        //Main.log(LoginContainer.control.Login.sid);

        if (Template.dataMatch.Content.ContentItems[0].WebradioUrl != null) {
            Player.playAudioStream(Template.dataMatch.Content.ContentItems[0].WebradioUrl.replace("{SessionId}", LoginContainer.control.Login.sid));
        }

    });

    // -----

    $("body").bind("webradioNotAllowed", function (event, message) {
        //Main.log("webradioNotAllowed...");
        Focus.setFocusedControlId("Ticker");
    });

    // -----

    $("body").bind("createIntro", function (event, introType) {

        switch (introType) {
            case "video":
                Player.setFullscreen();
                Template.swithPlayerLayersToIntroVideo(true);
                Player.setVideoURL(IntroContainer.control.Intro.mediaFile);
                Player.playVideo();
                break;
            case "image":
                var image = $("<img />").attr("src", IntroContainer.control.Intro.mediaFile);
                $("#Intro").append(image);
                setTimeout("$('#context').addClass('ready'); IntroContainer.control.Intro.introFinished();", IntroContainer.control.Intro.timer);
                break;

        }

    });

    // -----

    $("body").bind("introFinished", function (event, message) {

        Service.get(Main.setting.Server + "/Json/JsonWebService.aspx?ServiceOperation=GetNavigation&ServiceName=SplashScreen&PageType=TVApp&EplName=FCBayern&ct=40&cc=DE-DE", null, "splash", "createSplash");

    });

    // -----

    $("body").bind("networkError", function (event, errorType) {

        if (!Template.isErrorDisplayed) {
            Template.lastFocusedControlId = Focus.focusedControlId;
            ErrorContainer.control.Error.show(errorType);
            ErrorContainer.control.Error.takeControl();
            Template.isErrorDisplayed = true;
        }

    });

    // -----

});

// ----------------------------------

Template = {

  dataIntro : null,
  dataSplash : null,
  dataTv : null,
  dataVideo : null,
  dataNews : null,
  dataMatch : null,
  dataTicker : null,
  dataImpressum : null,
  menuFirsLoad : false,
  loadedControlName : "cVideo",
  videoUrl : null,
  isVideoMode : false,
  isLogged: false,
  isLoginDisplayed: false,
  isImpressumDisplayed: false,
  isErrorDisplayed: false,
  lastFocusedControlId: null,
  currentModule: null,
  appState: null,
  videoIndex: null,
  NEWS : 1,
  MATCH : 2,
  VIDEO : 3,
  INTRO : 4,
  SPLASH : 5

};

// ----------------------------------

Template.init = function () {

};

// ----------------------------------

Template.createIntro = function () {

  this.appState = this.INTRO;

  Service.isUpdating = true;

  IntroContainer.control.Intro.create(this.dataIntro.Content);

};

// ----------------------------------

Template.createSplash = function () {

  this.swithPlayerLayersToIntroVideo(false);

  StatusContainer.control.Status.create();
  StatusContainer.control.Status.show();

  this.tryLogin();

  Service.showLoader();

  $("#Splash").load('splash.html', function () {

    $(Template.dataSplash.Navigation.Items).each(function (index, item) {

      var box = $("<div />").attr("splashbox", "true").attr("title", item.Action);

      //  var image = $("<div />").addClass("image-container").html(item.IconImageFileName);
      //var img = $("<img/>").attr("src", "Theme/FCBayern/Images/Match.png");
      var img = $("<img/>").attr("src", item.IconImageFileName);
      var image = $("<div />").addClass("image-container").append(img);
      var imageBorder = $("<div />").addClass("image-border");
      var title = $("<div />").addClass("box-title").html(item.Title);

      box.append(image);
      box.append(imageBorder);
      box.append(title);

      $("#splashLinks").append(box);

    });

    Service.hideLoader();
    Focus.setFocusedControlId("Splash");
    SplashContainer.control.Splash.takeControl();
    SplashContainer.control.Splash.splashCount = 3;
    SplashContainer.control.Splash.setFirstFocus();
    SplashContainer.control.Splash.show();
  });

};

// ----------------------------------

Template.createTV = function () {

  this.currentModule = this.VIDEO;

  Service.showLoader();

  $("#TV").load('tv.html', function () {
    Service.hideLoader();
    TVsContainer.control.TV.takeControl();
    TVsContainer.control.TV.show();
    Player.setWindow();

    var onscreenRemote = $("<div />").attr("id", "Remote").html($("#TV #Remote"))
    $("body").append(onscreenRemote);
    //$("#TV").remove($("#TV #Remote"));	// SH DEL

    $("#videoOverlay").show();
    $("#pluginObjectPlayer").show();
    
    $("#pluginObjectPlayer").css('visibility','visible');	// SH ADD

    $("body").trigger('initMenuControls', [null]);

  });

};

// ----------------------------------

Template.createMatch = function () {

  this.currentModule = this.MATCH;

  var _this = this;

  Service.showLoader();

  $("#Match").load('match.html', function () {
    Service.hideLoader();

    Service.get(_this.dataMatch.Content.ContentItems[0].MediaUrl, null, "ticker", "createTicker");

    MatchContainer.control.Match.takeControl();
    MatchContainer.control.Match.createTimer(_this.dataMatch.Content.ContentItems[0].UpdateTimespan);
    MatchContainer.control.Match.show();


    $("body").trigger('initMatchControls', [null]);

  });

};

// ----------------------------------

Template.createNews = function () {

  this.currentModule = this.NEWS;

  Service.showLoader();

  $("#News").load('news.html', function () {
    //Service.hideLoader();
    NewsContainer.control.News.takeControl();
    NewsContainer.control.News.show();

    $("body").trigger('initNewsControls', [null]);

  });

};

// ----------------------------------

Template.updateTicker = function () {

  //Focus.setFocusedControlId("Ticker");

  Service.isBuilding = true;

  if (Template.dataTicker.child != undefined) {

    if (TickerContainer.control.Ticker != null) {
      TickerContainer.control.Ticker.updateContent(Template.dataTicker.child.kommentare[0]);
      MatchAktuelContainer.control.MatchAktuel.updateContent(Template.dataTicker.child.game_infos[0]);
    }
  }

  Service.isBuilding = false; ;

}

// ----------------------------------

Template.createTicker = function () {

  Service.isBuilding = true;

  if (Template.dataTicker.child != undefined) {
    if (TickerContainer.control.Ticker != null) {
      MatchAktuelContainer.control.MatchAktuel.createContent(Template.dataTicker.child.game_infos[0], Template.dataMatch.Content.ContentItems[0]);
      TickerContainer.control.Ticker.createContent(Template.dataTicker.child.kommentare[0]);
    }
  } else {
    MatchAktuelContainer.control.MatchAktuel.createContent(null, Template.dataMatch.Content.ContentItems[0]);
  }

  if (LoginContainer.control.Login.isUserLogged) {
    if (WebradioContainer.control.Webradio != null)
      WebradioContainer.control.Webradio.create(Template.dataMatch.Content.ContentItems[0].WebradioUrl);
  }


  Service.isBuilding = false; ;

}

// ----------------------------------

Template.createVideoList = function () {

  if (CarouselContainer.control.Carousel == null)
    return;


  CarouselContainer.control.Carousel.createContent(this.dataVideo.Content.ContentItems);

  if (this.menuFirsLoad) {
    MenuContainer.control.Menu.createSelectedItem();
  }

  Focus.setFocusedControlId("Carousel");
  CarouselContainer.control.Carousel.takeControl();

};

// ----------------------------------

Template.displayImage = function (imgSrc, title, date) {
	
	$("#videoOverlay .videoDate").html(date);
	$("#videoOverlay .videoTitle").html(title);
	$("#videoImage img.videoImage").attr("src", imgSrc);

};

// ----------------------------------

Template.swithPlayerLayersToVideo = function () {

  //Main.log("Template.swithPlayerLayersToVideo: " + this.currentModule);

  if (this.currentModule != this.VIDEO)
    return;

  $("#videoImage").css("z-index", "65");
  $("#pluginObjectPlayer").css("z-index", "66");
  $("#videoOverlay .videoTitle").css("top", "316px");
  $("#videoImage img.bigPlayButton").hide();

  if (Player.display != Player.FULLSCREEN)
    $("#Remote").show();

  this.isVideoMode = true;

};

// ----------------------------------

Template.swithPlayerLayersToIntroVideo = function (state) {

  //Main.log("Template.swithPlayerLayersToIntroVideo: " + this.currentModule);

  if (state) {
    $("#pluginObjectPlayer").css("z-index", "96");
  } else {
    $("#pluginObjectPlayer").css("z-index", "0");
  }

};

// ----------------------------------

Template.swithPlayerLayersToImage = function () {

  if (this.currentModule != this.VIDEO)
    return;
  
  $("#videoImage").css("z-index", "66");
  $("#pluginObjectPlayer").css("z-index", "65");
  $("#videoOverlay").show();
  $("#videoOverlay .videoTitle").css("top", "335px");
  $("#Remote").hide();

  this.isVideoMode = false;

};

// ----------------------------------

Template.showOverlay = function () {
  $("#videoOverlay").show();
  $("#Remote").show();
};

// ----------------------------------

Template.hideOverlay = function () {
  $("#videoOverlay").hide();
  $("#Remote").hide();
};

// ----------------------------------

Template.unload = function () {
  //Main.log("!!!!!!!!!!!!!!!!!!!!! unload !!!!!!!!!!!!!!!!!!!!!!!!!!!!!");

  //if (Analytics.videoItemQueryOpen)
  //  Analytics.itemClose(Template.AnalyticsItemClose);

  Analytics.callAnalytics(Main.setting.App.Analytics.AppCloseUrl);
  Player.Stop();

};

// ----------------------------------

Template.tryLogin = function () {

  Storage.put('sid', "");
  LoginContainer.control.Login.loadFromCokie();
  LoginContainer.control.Login.tryLogin();

};

// ----------------------------------

Template.impressumFillText = function () {

  ImpressumContainer.control.Impressum.fillText(this.dataImpressum.Content);
  ImpressumContainer.control.Impressum.takeControl();
  Focus.setFocusToElement($("#Impressum"));
  ImpressumContainer.control.Impressum.show();

}

// ----------------------------------

Template.checkVersion = function () {

    var nPlug = document.getElementById("pluginObjectNNavi");
    var fimware = nPlug.GetFirmware();

    var index = fimware.indexOf("-");
    var index2 = fimware.lastIndexOf("-");

    var fimwareYear = fimware.substring(index2 - 4, index2);

    var year = parseInt(fimwareYear);

    if (year == 2012) {
        $('head').append("<link rel='stylesheet' type='text/css' href='Theme/FCBayern/Css/SamsungTV2012.css' />");
    }

    if (year == 2013) {
        $('head').append("<link rel='stylesheet' type='text/css' href='Theme/FCBayern/Css/SamsungTV2013.css' />");
    }

};

// ----------------------------------






