
/// <reference path="../../main.js"/>

/// <summary>Audio helper.</summary>

var Audio = {
    plugin: null
}

// ------------------------------------------------------------------
Audio.init = function () {
  /// <summary>Audio initialization</summary>

  //Main.log("Audio.init");

    var success = true;

    this.plugin = document.getElementById("pluginAudio");

    if (!this.plugin) {
        success = false;
    }


    return success;
}

// -------------------------------------------------------------------
Audio.setRelativeVolume = function (delta) {
    /// <summary>Set relative volume.</summary>
    this.plugin.SetVolumeWithKey(delta);
}

// -------------------------------------------------------------------
Audio.getVolume = function () {
    /// <summary>Get volume.</summary>
    return this.plugin.GetVolume();
}
