﻿
// ---- ARTIKEL -------------------------------------

ArtikelContainer = {

  control: new Array()

};

$(document).ready(function () {

    $("body").bind("initNewsControls", function (event, message) {

      $("div[iscontrol=true][controltype=artikel]").each(function (index, item) {

            var name = $(item).attr("Id");
            name = new ControlArtikel(name);
            ArtikelContainer.control[$(item).attr("Id")] = name;
            name.init();

            $("body").trigger('subControlCreated', [$(item).attr("Id"), $(item).attr("parent")]);

        });

    });

});

// constructor ---------------------------------------

function ControlArtikel(controlId) {

  this.controlId = controlId;
  this.control = $("#" + controlId);
  this.state = this.NOTFOCUSED;
  this.FOCUSED = 1;
  this.NOTFOCUSED = 2;
  this.step = 17;
  this.scrollStep = 0;
  this.currentStep = 0;

  // -----------------------------------------

  this.init = function () {

      //Main.log(controlId + " init");

      var _this = this;

      //----

      $(this.control).bind("enterKeyPressed", function (event, message) {
          //Main.log("enter pressed in: " + controlId);

//          if (_this.state != _this.FOCUSED) {
//              _this.state = _this.FOCUSED;
//              $("body").trigger('controlEvent', ["takeControl", _this.controlId]);
//              _this.setFirstFocus();
//          } else {

//          }

      });

      //----

      $(this.control).bind("focusSet", function (event, message) {
          _this.doDefaultAction();

      });

      //----

      $("body").bind("controlKeyPressed" + this.controlId, function (event, direction, controlId) {

          if (_this.controlId != controlId)
              return;

          if (_this.state == _this.FOCUSED) {

              switch (direction) {
                  case "up":
                      _this.moveUp();
                      break;
                  case "down":
                      _this.moveDown();
                      break;
                  case "left":
                      _this.moveLeft();
                      break;
                  case "right":
                      _this.moveRight();
                      break;
                  case "enter":
                      //_this.state = _this.NOTFOCUSED;
                      //_this.clearFocus();
                      //$("body").trigger('remoteEnterPressed', [null]);
                      break;
                  case "return":
                      _this.leaveControl();
                      _this.deinit();
                      $("body").trigger('artikelReturnPressed', [null]);
                      break;
              }
          }

      });

      //----

  };

  // -----------------------------------------

  this.getControlName = function () {
    return controlId;
  };

  // -----------------------------------------

  this.deinit = function () {

    $(this.control).unbind("focusSet");
    $("body").unbind("enterKeyPressed" + this.controlId);
    $("body").unbind("controlKeyPressed" + this.controlId);

    this.hide();
    this.control.html("");

  };

  // -----------------------------------------

  this.hide = function () {

    this.control.hide();

  };

  // -----------------------------------------

  this.show = function () {

    this.control.show();

  };

  // -----------------------------------------

  this.takeControl = function () {
      this.state = this.FOCUSED;
      this.setFirstFocus();
      $("body").trigger('controlEvent', ["takeControl", this.controlId]);

  };

  // -----------------------------------------

  this.leaveControl = function (direction) {

    this.state = this.NOTFOCUSED;
    this.clearFocus();
    $(".scrollerBarArtikel", this.control).first().hide();
    $("body").trigger('controlEvent', ["leaveControl", null]);
    //$("body").trigger('keyPressed', [direction]);

  };

  // -----------------------------------------

  this.setFirstFocus = function () {

    $(".scrollerBarArtikel", this.control).first().show();
    $(".content", this.control).addClass("control-focus");

  };

  // -----------------------------------------

  this.clearFocus = function () {

    $(".control-focus", this.control).removeClass("control-focus");

  };

  // -----------------------------------------

  this.moveLeft = function () {

    this.leaveControl("left");

  };

  // -----------------------------------------

  this.moveRight = function () {

    this.leaveControl("right");

  };

  // -----------------------------------------

  this.moveUp = function () {

    var top = $("#" + this.controlId + " .content-container").position().top;
    var stop = $("#" + this.controlId + " .scrolerArtikel").position().top;

    //Main.log("!!!!!!!!!!!!!: " + top);

    var height = $("#" + this.controlId + " .content-container").height();
    var height2 = $("#" + this.controlId + " .content").height();

    var scrolerbarheight = $("#" + this.controlId + " .scrollerBarArtikel").height();
    var scrolerheight = $("#" + this.controlId + " .scrolerArtikel").height();

    //Main.log("top: " + top);
    //Main.log("stop: " + stop);
    //Main.log("height: " + height);
    //Main.log("height2: " + height2);
    //Main.log("scrolerbarheight: " + scrolerbarheight);
    //Main.log("scrolerheight: " + scrolerheight);

    //Main.log("scrolerbarheight: " + scrolerbarheight);
    //Main.log("scrolerheight: " + scrolerheight);
    //Main.log("step : " + this.scrollStep);

    if (top > 0) return;

    $("#" + this.controlId + " .content-container").css("top", (top + this.step));
    $("#" + this.controlId + " .scrolerArtikel").css("top", ($("#" + this.controlId + " .scrolerArtikel").position().top - this.scrollStep));
    this.currentStep --;


  };

  // -----------------------------------------

  this.moveDown = function () {

    var top = $(".content-container", this.control).position().top;
    var stop = $("#" + this.controlId + " .scrolerArtikel").position().top;
    var height = $(".content-container", this.control).height();
    var height2 = $(".content", this.control).height();

    var scrolerbarheight = $(".scrollerBarArtikel", this.control).height();
    var scrolerheight = $(".scrolerArtikel", this.control).height();

    //Main.log("top b: " + top);
    //Main.log("stop: " + stop);
    //Main.log("height: " + height);
    //Main.log("height2: " + height2);

    //Main.log("delta: " + (height2 - height - this.step));

    //Main.log("!!!!!!!!!!!!!: " + top + " == " + (height2 - height));

    //Main.log("scrolerbarheight: " + scrolerbarheight);
    //Main.log("scrolerheight: " + scrolerheight);
    //Main.log("step : " + this.scrollStep);

    //Main.log("........... " + ($(".scrollerBarArtikel", this.control).offset().top + scrolerbarheight));
    //Main.log("........... " + ($(".scrolerArtikel", this.control).offset().top + scrolerheight));

    //if ((top) < (height2 - height + this.step)) return;
    if ($(".scrollerBarArtikel", this.control).offset().top + scrolerbarheight <= $(".scrolerArtikel", this.control).offset().top + scrolerheight) return;


    $(".content-container", this.control).css("top", (top - this.step));
    $(".scrolerArtikel", this.control).css("top", ($(".scrolerArtikel", this.control).position().top + this.scrollStep));
    this.currentStep++;

    top = $(".content-container", this.control).position().top;
    stop = $("#" + this.controlId + " .scrolerArtikel").position().top;
    //Main.log("top a: " + top);
    //Main.log("stop a: " + stop);
    //Main.log("this.currentStep :" + this.currentStep);

  };

  // -----------------------------------------

//  this.createDummyContent = function (contentId) {

//    var header = $("<div />").addClass("header"); ;
//    var content = $("<div />").addClass("content"); ;

//    var date = $("<div />").addClass("date").html("Donnerstag, ab 20:00 Uhr");
//    var title = $("<div />").addClass("title").html(contentId + "). Jupp Heynckes im Video Chat");
//    var img = $("<img />").attr("src", "http://www.fcbayern.telekom.de/media/images/spieler_11_12_/jubel/270/jubel_get_021111.jpg")
//    var image = $("<div />").append(img);
//    var text = $("<div />").addClass("text").html("Sed magna felis, porttitor eu sodales vel, gravida ac diam. Fusce dictum, enim mollis pretium porta, eros mi fermentum eros, eget condimentum orci tellus non mauris. Donec est nulla, viverra vel tristique sit amet, hendrerit id libero. Proin ultricies, lacus sed facilisis condimentum, lorem enim ultrices ante, id luctus dolor enim eget tellus? Mauris rhoncus porttitor sapien consectetur congue. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Maecenas dapibus dui et nulla accumsan at pretium velit consequat!");

//    header.append(date);
//    header.append(title);
//    content.append(image);
//    content.append(text);


//    this.control.append(header);
//    this.control.append(content);

//};

// -----------------------------------------

  this.createContent = function (contentId) {
	  
	  $(".scrollerBarArtikel", this.control).first().hide();

      var item = Template.dataNews.Content.ContentItems[contentId];

      var header = $("<div />").addClass("header"); ;
      var content = $("<div />").addClass("content");

      var date = $("<div />").addClass("date").html(item.PubDate);
      var title = $("<div />").addClass("title").html(item.Title);
      var img = $("<img />").attr("src", item.Image);
      var imageContainer = $("<div />").addClass("imageContainer");
      var image = $("<div />").append(img);
      var text = $("<div />").addClass("text").html(item.Description);
      var contentContainer = $("<div />").addClass("content-container");
      
      var art_this = this;
      
      /////////////////////////////////////// SH ADD 2012.03.07  //////////////////////////////
      var v_img = new Image();
      v_img.src = $(img).attr('src');
      
      v_img.onload = function() {
    	  $(".scrollerBarArtikel", this.control).first().hide();
    	  
    	  v_height = v_img.height;
			
    	  if(parseInt(v_height) > 0) {
    		  $(img).css('height',v_height);
    		  $(img).attr('height',v_height);
    	  }
			
    	  $(".scrolerArtikel", art_this.control).height(60);

          header.append(date);
          header.append(title);

          imageContainer.append(image);
          contentContainer.append(imageContainer);
          contentContainer.append(text);

          content.append(contentContainer);

          art_this.control.append(header);
          art_this.control.append(content);

          $(".scrolerArtikel", art_this.control).css("top", 0);

          var top = $(".content-container", art_this.control).position().top;

          var height = $("#" + art_this.controlId + " .content-container").height();
          var height2 = $("#" + art_this.controlId + " .content").height();

          var scrolerbarheight = $(".scrollerBarArtikel", art_this.control).height();
          var scrolerheight = $(".scrolerArtikel", art_this.control).height();

          var stepCount = Math.round((height - height2) / art_this.step);

          // this.scrollStep == Math.floor((scrolerbarheight - scrolerheight) / stepCount);
          art_this.scrollStep = Math.floor((scrolerbarheight - scrolerheight) / stepCount);
          art_this.currentStep = 0;

          $(".scrolerArtikel", art_this.control).height(scrolerbarheight - (art_this.scrollStep * stepCount));
          
          $(".scrollerBarArtikel", this.control).first().show();
      }
  };

  // -----------------------------------------

  this.loadContent = function (contentId) {

    $(".header", this.control).remove();
    $(".content", this.control).remove();

    this.createContent(contentId);

  };

// -----------------------------------------

    this.doDefaultAction = function () {

        this.state = this.FOCUSED;
        $("body").trigger('controlEvent', ["takeControl", this.controlId]);
        this.setFirstFocus(this.selectedRow);

    };

// -----------------------------------------

}


