﻿// ---- ERROR -------------------------------------

ErrorContainer = {

  control: new Array()

};

$(document).ready(function () {

  $("body").bind("initControls", function (event, message) {

    $(".error.control").each(function (index, item) {

      var name = $(item).attr("Id");
      name = new ControlError(name);
      ErrorContainer.control[$(item).attr("Id")] = name;
      name.init();

      $("body").trigger('controlCreated', [null]);

    });

  });

});

// constructor ---------------------------------------

function ControlError(controlId) {

  this.controlId = controlId;
  this.control = $("#" + controlId);
  this.state = this.NOTFOCUSED;
  this.FOCUSED = 1;
  this.NOTFOCUSED = 2;

  // -----------------------------------------

  this.init = function () {

    //Main.log(controlId + " init");

    var _this = this;


    //----

    $(this.control).bind("enterKeyPressed", function (event, message) {

    });

    //----

    $("body").bind("controlKeyPressed" + this.controlId, function (event, direction, controlId) {

      if (_this.controlId != controlId)
        return;

      if (_this.state == _this.FOCUSED) {

        switch (direction) {
          case "up":
            break;
          case "down":
            break;
          case "left":
            break;
          case "right":
            break;
          case "enter":
            _this.deinit();
            $("body").trigger('errorReturnPressed', [null]);
            break;
          case "return":
            _this.deinit();
            $("body").trigger('errorReturnPressed', [null]);
            break;
        }
      }
    });

  };

  // -----------------------------------------

  this.getControlName = function () {
    return controlId;
  };

  // -----------------------------------------

  this.deinit = function () {

    $("#" + this.controlId + " .errorContent").html("");
    this.hide();

  };

  // -----------------------------------------

  this.hide = function () {

    //Main.log("Error hide");

    this.control.hide();

  };

  // -----------------------------------------

  this.show = function (errorType) {

    //Main.log("Error show");

    $(".errorContent", this.control).html("<div>" + eval("Main.setting.Error." + errorType) + "</div>");

    this.control.show();

  };

  // -----------------------------------------

  this.takeControl = function () {
    this.state = this.FOCUSED;
    this.setFirstFocus();
    $("body").trigger('controlEvent', ["takeControl", this.controlId]);
  };

  // -----------------------------------------

  this.leaveControl = function (direction) {

    this.state = this.NOTFOCUSED;
    this.clearFocus();
    $("body").trigger('controlEvent', ["leaveControl", null]);

  };

  // -----------------------------------------

  this.setFirstFocus = function () {


  };

  // -----------------------------------------

  this.clearFocus = function () {


  };

  // -----------------------------------------


}