﻿
// ----NEWS -------------------------------------

NewsContainer = {

  control: new Array()

};

$(document).ready(function () {

  $("body").bind("initControls", function (event, message) {

    $(".news.control").each(function (index, item) {

      var name = $(item).attr("Id");
      name = new ControlNews(name);
      NewsContainer.control[$(item).attr("Id")] = name;
      name.init();

      $("body").trigger('controlCreated', [null]);

    });

  });

});

// constructor ---------------------------------------

function ControlNews(controlId) {

  this.controlId = controlId;
  this.control = $("#" + controlId);
  this.state = this.NOTFOCUSED;
  this.FOCUSED = 1;
  this.NOTFOCUSED = 2;

  // -----------------------------------------

  this.init = function () {

    //Main.log(controlId + " init");

    var _this = this;

    //----

    $(this.control).bind("enterKeyPressed", function (event, message) {
      //Main.log("enter pressed in: " + controlId);
    });

    //----

    $("body").bind("controlKeyPressed" + this.controlId, function (event, direction, controlId) {

      if (_this.controlId != controlId)
        return;

      if (_this.state == _this.FOCUSED) {
        switch (direction) {
          case "up":
            break;
          case "down":
            break;
          case "left":
            break;
          case "right":
            break;
          case "enter":
            break;
          case "return":
            _this.leaveControl();
            $("body").trigger('newsReturnPressed', [null]);
            break;
        }
      }

    });

    //----

  };

  // -----------------------------------------

  this.getControlName = function () {
    return controlId;
  };

  // -----------------------------------------

  this.deinit = function () {

    this.hide();
    this.control.html("");

  };

  // -----------------------------------------

  this.hide = function () {

    this.control.hide();

  };

  // -----------------------------------------

  this.show = function () {

    this.control.show();

  };

  // -----------------------------------------

  this.takeControl = function () {
    this.state = this.FOCUSED;
    this.setFirstFocus();
    $("body").trigger('controlEvent', ["takeControl", this.controlId]);
  };

  // -----------------------------------------

  this.leaveControl = function (direction) {

    this.state = this.NOTFOCUSED;
    this.clearFocus();
    $("body").trigger('controlEvent', ["leaveControl", null]);
    $("body").trigger('keyPressed', [direction]);
    this.deinit();

  };

  // -----------------------------------------

  this.setFirstFocus = function () {

  };

  // -----------------------------------------

  this.clearFocus = function () {

  };

  // -----------------------------------------

  this.moveLeft = function () {

  };

  // -----------------------------------------

  this.moveRight = function () {

  };

  // -----------------------------------------

  this.moveUp = function () {

  };

  // -----------------------------------------

  this.moveDown = function () {

  };

  // -----------------------------------------

}


