﻿
// ----STATUS -------------------------------------

StatusContainer = {

  control: new Array()

};

$(document).ready(function () {

  $("body").bind("initControls", function (event, message) {

    $(".status.control").each(function (index, item) {

      var name = $(item).attr("Id");
      name = new ControlStatus(name);
      StatusContainer.control[$(item).attr("Id")] = name;
      name.init();

      $("body").trigger('controlCreated', [null]);

    });

  });

});

// constructor ---------------------------------------

function ControlStatus(controlId) {

  this.controlId = controlId;
  this.control = $("#" + controlId);
  this.state = this.NOTFOCUSED;
  this.FOCUSED = 1;
  this.NOTFOCUSED = 2;

  // -----------------------------------------

  this.init = function () {

    //Main.log(controlId + " init");

  };

  // -----------------------------------------

  this.getControlName = function () {
    return controlId;
  };

  // -----------------------------------------

  this.show = function () {

    this.control.show();

  };

  // -----------------------------------------

  this.create = function () {

    var colors = $("<div />").addClass("colors");

    var refresh = $("<div />").addClass("refresh");
    var info = $("<div />").addClass("info");

    var red = $("<span />").html("An-/Abmelden").addClass("login");
    var blue = $("<span />").html("Impressum").addClass("about");

    colors.append(red);
    colors.append(blue);

    this.control.append(refresh)
    this.control.append(info)
    this.control.append(colors)

  };

  // -----------------------------------------

  this.setInfoText = function (text) {

    $(".info", this.control).text(text);

  };

  // -----------------------------------------

}


